---
stages:
#  - preclean
  - build
  - check
  - configure
  - test
  - cleanup

variables:
  VAR_GW: 192.168.201.1
  VAR_VENV: python-venvs/ansible  #this should be an environmental var
  VAR_USER: automation-user
  VAR_IMAGE: 'https://cloud-images.ubuntu.com/focal/current/focal-server-cloudimg-amd64.img'
  VAR_OS: "ubuntu20.04"
  VAR_CP_CPU: 4
  VAR_WORK_CPU: 4
  VAR_CP_MEM: 6144
  VAR_WORK_MEM: 6144
  VAR_DISK: 30
  VAR_ADD_DISK1: 100   #rook 
  VAR_ADD_DISK2: 50    #local

#teardown-vms:
#  stage: preclean  
#  script:
#    - VMS=(cp1 cp2 worker1 worker2 worker3)
#    - for VM in "${VMS[@]}"; do ./cleanup-vm.bash -n "$VM"; done
#  when: always
#  tags:
#    - kvm

# split VM builds up so they can be built on different runners 
# to carry out e2e network testing 
build-cp1:
  stage: build
  variables:
    VAR_VM_NAME: cp1
    VAR_VM_IP: "192.168.201.12/24"
  script:
    - ./gen-ssh.bash -n $VAR_VM_NAME -u $VAR_USER
    - ./create-vm.bash -n $VAR_VM_NAME -u $VAR_USER -G $VAR_GW -I "$VAR_VM_IP" -c $VAR_CP_CPU -m $VAR_CP_MEM -i "$VAR_IMAGE" -o "$VAR_OS" -r $VAR_DISK
  tags:
    - kvm

build-cp2:
  stage: build
  variables:
    VAR_VM_NAME: cp2 
    VAR_VM_IP: "192.168.201.13/24"
  script:
    - ./gen-ssh.bash -n $VAR_VM_NAME -u $VAR_USER
    - ./create-vm.bash -n $VAR_VM_NAME -u $VAR_USER -G $VAR_GW -I "$VAR_VM_IP" -c $VAR_CP_CPU -m $VAR_CP_MEM -i "$VAR_IMAGE" -o "$VAR_OS" -r $VAR_DISK
  tags:
    - kvm

build-worker1:
  stage: build
  variables:
    VAR_VM_NAME: worker1
    VAR_VM_IP: "192.168.201.24/24"
  script:
    - ./gen-ssh.bash -n $VAR_VM_NAME -u $VAR_USER
    - ./create-vm.bash -n $VAR_VM_NAME -u $VAR_USER -G $VAR_GW -I "$VAR_VM_IP" -c $VAR_WORK_CPU -m $VAR_WORK_MEM -i "$VAR_IMAGE" -o "$VAR_OS" -r $VAR_DISK
    - ./create-disk.bash -n $VAR_VM_NAME -d $VAR_ADD_DISK1 -l vdb
    - ./create-disk.bash -n $VAR_VM_NAME -d $VAR_ADD_DISK2 -l vdc
  tags:
    - kvm

build-worker2:
  stage: build
  variables:
    VAR_VM_NAME: worker2
    VAR_VM_IP: "192.168.201.25/24"
  script:
    - ./gen-ssh.bash -n $VAR_VM_NAME -u $VAR_USER
    - ./create-vm.bash -n $VAR_VM_NAME -u $VAR_USER -G $VAR_GW -I "$VAR_VM_IP" -c $VAR_WORK_CPU -m $VAR_WORK_MEM -i "$VAR_IMAGE" -o "$VAR_OS" -r $VAR_DISK
    - ./create-disk.bash -n $VAR_VM_NAME -d $VAR_ADD_DISK1 -l vdb
    - ./create-disk.bash -n $VAR_VM_NAME -d $VAR_ADD_DISK2 -l vdc
  tags:
    - kvm

build-worker3:
  stage: build
  variables:
    VAR_VM_NAME: worker3 
    VAR_VM_IP: "192.168.201.26/24"
  script:
    - ./gen-ssh.bash -n $VAR_VM_NAME -u $VAR_USER
    - ./create-vm.bash -n $VAR_VM_NAME -u $VAR_USER -G $VAR_GW -I "$VAR_VM_IP" -c $VAR_WORK_CPU -m $VAR_WORK_MEM -i "$VAR_IMAGE" -o "$VAR_OS" -r $VAR_DISK
    - ./create-disk.bash -n $VAR_VM_NAME -d $VAR_ADD_DISK1 -l vdb
    - ./create-disk.bash -n $VAR_VM_NAME -d $VAR_ADD_DISK2 -l vdc
  tags:
    - kvm

check-vms:
  stage: check
  script:
    - VMS=(cp1 cp2 worker1 worker2 worker3)
    - for VM in "${VMS[@]}"; do ./check-vm.bash -n "$VM"; done
  tags:
    - kvm

configure-vms:
  stage: configure
  script:
    - source $HOME/$VAR_VENV/bin/activate
    - ansible-galaxy install -r requirements.yml --force
    - ansible-inventory -i inventory.yml --list
    - ansible-playbook -i inventory.yml kube-config-v2.yaml --user $VAR_USER -v
    - deactivate
    - virsh list --all
  tags:
    - kvm

run-test:
  stage: test
  script:
    - source $HOME/$VAR_VENV/bin/activate
    - ansible-playbook -i inventory.yml kube-test-playbook.yml --user $VAR_USER -v
    - deactivate
  tags:
    - kvm

teardown-vm:
  stage: cleanup
  script:
    - VMS=(cp1 cp2 worker1 worker2 worker3)
    - for VM in "${VMS[@]}"; do ./cleanup-vm.bash -n "$VM"; done
  when: manual 
  tags:
    - kvm
